> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create or update reusable blocks

POST https://rest.test.zuora.com/notifications/reusable-blocks/import
Content-Type: application/json

Creates reusable blocks if you do not specify block IDs, or updates existing reusable blocks if you specify valid block IDs. All fields must be provided for each reusable block you want to update.

The maximum number of reusable blocks that you can create or update by one call is 1,000.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/events-and-notifications/notifications/create-or-update-reusable-blocks

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

### Body (application/json)

This endpoint expects a CreateOrUpdateReusableBlockRequest.

- `allowPartialSuccess` (boolean, optional) — When set to false, the call will fail if one or multiple instances fail to import, and a 200 response is returned if all reusable blocks have been successfully updated. When set to true, a success (200) response is returned if one or more instances have imported successfully. All failed instances are also returned in the response.
- `reusableBlocks` (list of CreateOrUpdateReusableBlockFormat, optional) — A container for reusable blocks.

## Response

### 200

OK

- `reasons` (list of string, optional) — Returns an empty array if the request succeeds.

## Types

### CreateOrUpdateReusableBlockFormat

- `category` (enum, required) — The category of the reusable block. You can filter blocks by category when editing email templates in the UI.
  - Allowed values: `Headers`, `Footers`, `Other`
- `content` (string, required) — The content of the reusable block, which is automatically inserted into email templates when sending email notifications.
- `name` (string, required) — The name of the reusable block. The value must be unique across all blocks.
- `active` (boolean, optional, default: true) — The status of the reusable block. Only active blocks can be embedded into email templates.
- `id` (string, optional) — ID of an existing reusable block. Specify this field if you want to update an existing reusable block. You must provide all fields when updating an existing reusable block.
- `number` (string, optional) — The number of the reusable block. The value must be unique across all blocks. If not specified, a unique value will be provided by default.
- `tags` (list of string, optional) — List of tags that help you quickly locate reusable blocks when editing email templates in the UI by using the tag filter.

## Examples

### Create a reusable block

**Request**

```json
{
  "allowPartialSuccess": true,
  "reusableBlocks": [
    {
      "category": "Footers",
      "content": "(The content of the block)",
      "name": "Footer Block"
    }
  ]
}
```

**Response**

```json
{
  "reasons": []
}
```

**SDK Code**

```python Create a reusable block
import requests

url = "https://rest.test.zuora.com/notifications/reusable-blocks/import"

payload = {
    "allowPartialSuccess": True,
    "reusableBlocks": [
        {
            "category": "Footers",
            "content": "(The content of the block)",
            "name": "Footer Block"
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Create a reusable block
const url = 'https://rest.test.zuora.com/notifications/reusable-blocks/import';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"allowPartialSuccess":true,"reusableBlocks":[{"category":"Footers","content":"(The content of the block)","name":"Footer Block"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Create a reusable block
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/notifications/reusable-blocks/import"

	payload := strings.NewReader("{\n  \"allowPartialSuccess\": true,\n  \"reusableBlocks\": [\n    {\n      \"category\": \"Footers\",\n      \"content\": \"(The content of the block)\",\n      \"name\": \"Footer Block\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Create a reusable block
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/notifications/reusable-blocks/import")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"allowPartialSuccess\": true,\n  \"reusableBlocks\": [\n    {\n      \"category\": \"Footers\",\n      \"content\": \"(The content of the block)\",\n      \"name\": \"Footer Block\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Create a reusable block
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/notifications/reusable-blocks/import")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"allowPartialSuccess\": true,\n  \"reusableBlocks\": [\n    {\n      \"category\": \"Footers\",\n      \"content\": \"(The content of the block)\",\n      \"name\": \"Footer Block\"\n    }\n  ]\n}")
  .asString();
```

```php Create a reusable block
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/notifications/reusable-blocks/import', [
  'body' => '{
  "allowPartialSuccess": true,
  "reusableBlocks": [
    {
      "category": "Footers",
      "content": "(The content of the block)",
      "name": "Footer Block"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Create a reusable block
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/notifications/reusable-blocks/import");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"allowPartialSuccess\": true,\n  \"reusableBlocks\": [\n    {\n      \"category\": \"Footers\",\n      \"content\": \"(The content of the block)\",\n      \"name\": \"Footer Block\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Create a reusable block
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "allowPartialSuccess": true,
  "reusableBlocks": [
    [
      "category": "Footers",
      "content": "(The content of the block)",
      "name": "Footer Block"
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/notifications/reusable-blocks/import")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Update a reusable block

**Request**

```json
{
  "allowPartialSuccess": true,
  "reusableBlocks": [
    {
      "category": "Headers",
      "content": "(The content of the block)",
      "name": "Header Block",
      "active": true,
      "id": "385bcf09b2aa4a628098a88f62552180",
      "number": "RB-00000010",
      "tags": [
        "logo"
      ]
    }
  ]
}
```

**Response**

```json
{
  "reasons": []
}
```

**SDK Code**

```python Update a reusable block
import requests

url = "https://rest.test.zuora.com/notifications/reusable-blocks/import"

payload = {
    "allowPartialSuccess": True,
    "reusableBlocks": [
        {
            "category": "Headers",
            "content": "(The content of the block)",
            "name": "Header Block",
            "active": True,
            "id": "385bcf09b2aa4a628098a88f62552180",
            "number": "RB-00000010",
            "tags": ["logo"]
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Update a reusable block
const url = 'https://rest.test.zuora.com/notifications/reusable-blocks/import';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"allowPartialSuccess":true,"reusableBlocks":[{"category":"Headers","content":"(The content of the block)","name":"Header Block","active":true,"id":"385bcf09b2aa4a628098a88f62552180","number":"RB-00000010","tags":["logo"]}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Update a reusable block
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/notifications/reusable-blocks/import"

	payload := strings.NewReader("{\n  \"allowPartialSuccess\": true,\n  \"reusableBlocks\": [\n    {\n      \"category\": \"Headers\",\n      \"content\": \"(The content of the block)\",\n      \"name\": \"Header Block\",\n      \"active\": true,\n      \"id\": \"385bcf09b2aa4a628098a88f62552180\",\n      \"number\": \"RB-00000010\",\n      \"tags\": [\n        \"logo\"\n      ]\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Update a reusable block
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/notifications/reusable-blocks/import")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"allowPartialSuccess\": true,\n  \"reusableBlocks\": [\n    {\n      \"category\": \"Headers\",\n      \"content\": \"(The content of the block)\",\n      \"name\": \"Header Block\",\n      \"active\": true,\n      \"id\": \"385bcf09b2aa4a628098a88f62552180\",\n      \"number\": \"RB-00000010\",\n      \"tags\": [\n        \"logo\"\n      ]\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Update a reusable block
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/notifications/reusable-blocks/import")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"allowPartialSuccess\": true,\n  \"reusableBlocks\": [\n    {\n      \"category\": \"Headers\",\n      \"content\": \"(The content of the block)\",\n      \"name\": \"Header Block\",\n      \"active\": true,\n      \"id\": \"385bcf09b2aa4a628098a88f62552180\",\n      \"number\": \"RB-00000010\",\n      \"tags\": [\n        \"logo\"\n      ]\n    }\n  ]\n}")
  .asString();
```

```php Update a reusable block
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/notifications/reusable-blocks/import', [
  'body' => '{
  "allowPartialSuccess": true,
  "reusableBlocks": [
    {
      "category": "Headers",
      "content": "(The content of the block)",
      "name": "Header Block",
      "active": true,
      "id": "385bcf09b2aa4a628098a88f62552180",
      "number": "RB-00000010",
      "tags": [
        "logo"
      ]
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Update a reusable block
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/notifications/reusable-blocks/import");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"allowPartialSuccess\": true,\n  \"reusableBlocks\": [\n    {\n      \"category\": \"Headers\",\n      \"content\": \"(The content of the block)\",\n      \"name\": \"Header Block\",\n      \"active\": true,\n      \"id\": \"385bcf09b2aa4a628098a88f62552180\",\n      \"number\": \"RB-00000010\",\n      \"tags\": [\n        \"logo\"\n      ]\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Update a reusable block
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "allowPartialSuccess": true,
  "reusableBlocks": [
    [
      "category": "Headers",
      "content": "(The content of the block)",
      "name": "Header Block",
      "active": true,
      "id": "385bcf09b2aa4a628098a88f62552180",
      "number": "RB-00000010",
      "tags": ["logo"]
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/notifications/reusable-blocks/import")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```